// ============================================================================
//
// Task10.c
// CBP 26-03-22
// Non - Thread-Safe Function
// Part of NoC Multi-Processing Workshops
// Status: 
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>

int nrProcs;
int count;

void lib_func() {
	// Following critical will make function thread-safe
	//#pragma omp critical
	count++;
	// Some library function stuff
}

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 10 ----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(16);

	#pragma omp parallel
	{
		lib_func();
	}

	printf("count = %d\n", count);

}