// ============================================================================
//
// Test4.c
// Sums elements of a vector uses a reduction clause
// CBP 25-03-22
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <omp.h>

int tid;
int nrProcs;
int sum;
int a[10];
int threadNr;
int sumLocal;
int count = 0;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 4 -----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(nrProcs);

	for (int i = 0; i < 10; i++) {
		a[i] = i;
	}
	sum = 0;

	while (count < 100) {
		sum = 0;
		// Without reduction sum will often fail
		//#pragma omp parallel 
		#pragma omp parallel reduction(+:sum)
		{

		#pragma omp for
			for (int i = 0; i < 10; i++) {
				sum += a[i];
			}
		}

		printf("sum = %d\n", sum);

		count++;
	}

}
