// ============================================================================
//
// Task12.c
// CBP 26-03-22
// Sections Construct applied to functions
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>

int nrProcs;
int tid;

void func1() {
	tid = omp_get_thread_num();
	printf("In function func1(): thread is %d\n", tid);
	// Some function stuff
	for (int i = 0; i < 10000; i++);
}

void func2() {
	tid = omp_get_thread_num();
	printf("In function func2(): thread is %d\n", tid);
	// Some function stuff
	for (int i = 0; i < 10; i++);
}

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 10 ----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(4);
	printf("Nr threads set to 4\n");

	#pragma omp parallel
	{
		#pragma omp sections
		{
			#pragma omp section
			func1();

			#pragma omp section
			func2();
		}

	}


}